if select(6, GetAddOnInfo("PitBull4_" .. (debugstack():match("[o%.][d%.][u%.]les\\(.-)\\") or ""))) ~= "MISSING" then return end

local PitBull4 = _G.PitBull4
if not PitBull4 then
	error("PitBull4_Jaraxxus requires PitBull4")
end

--[===[@debug@
LibStub("AceLocale-3.0"):NewLocale("PitBull4_Jaraxxus", "enUS", true, true)
--@end-debug@]===]
local L = LibStub("AceLocale-3.0"):GetLocale("PitBull4_Jaraxxus")

local lhc

local incinerate_fleshes = {
	[66237] = 30000, -- 10 man normal
	[67050] = 40000, -- 10 man heroic
	[67049] = 60000, -- 25 man normal
	[67051] = 85000, -- 25 man heroic
}

-- Regrowth for testing purposes
--[[local test_spell_id = 48443
incinerate_fleshes[test_spell_id] = 85000]]

-- Variables to hold the state
local if_target, if_duration, if_end_time, if_absorbed, if_spell_id, if_spell_name
local if_target_pending_healing = 0

local PitBull4_Jaraxxus = PitBull4:NewModule("Jaraxxus", "AceEvent-3.0")

PitBull4_Jaraxxus:SetModuleType("bar")
PitBull4_Jaraxxus:SetName(L["Jaraxxus"])
PitBull4_Jaraxxus:SetDescription(L["Bar to display state of Incinerate Flesh debuff."])
PitBull4_Jaraxxus:SetDefaults({ }, {
	colors = {
		absorbed = { 0, 1, 0 },
		pending = { 1, 1, 0 },
	}
})

local timer_frame = CreateFrame("Frame")
timer_frame:Hide()

function PitBull4_Jaraxxus:OnEnable()
	if not lhc then
		LoadAddOn("LibHealComm-4.0")
		lhc = LibStub("LibHealComm-4.0", true)
	end
	if lhc then
		lhc.RegisterCallback(self, "HealComm_HealStarted", "HealComm_HealEvent")
		lhc.RegisterCallback(self, "HealComm_HealUpdated", "HealComm_HealEvent")
		lhc.RegisterCallback(self, "HealComm_HealStopped", "HealComm_HealEvent")
		lhc.RegisterCallback(self, "HealComm_HealDelayed", "HealComm_HealEvent")
		lhc.RegisterCallback(self, "HealComm_ModifierChanged")
		lhc.RegisterCallback(self, "HealComm_GUIDDisappeared")
	end

	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	
	self:UpdateAll()
end

function PitBull4_Jaraxxus:OnDisable()
	timer_frame:Hide()
end

-- timer_frame's OnUpdate to handle moving the spark to show when the
-- debuff will fade.
timer_frame:SetScript("OnUpdate", function()
	if not if_target then return end
	local units = PitBull4.guid_to_unit_ids[if_target]
	if not units then return end
	local unit = next(units)
	if not unit then return end

  if not if_end_time or not if_duration then
		local filter = if_spell_id == test_spell_id and "HELPFUL" or "HARMFUL"
		local _
		_,_,_,_,_,if_duration,if_end_time = UnitAura(unit, if_spell_name, nil, filter)
	end
	if not if_end_time or not if_duration then return end

	local time_left = if_end_time - GetTime()
	if time_left <= 0 then
		time_left = 0	
	end
	if time_left > if_duration then
		time_left = if_duration
	end

	for frame in PitBull4:IterateFramesForGUID(if_target) do
		local bar = frame.Jaraxxus
		if bar then
			local spark = frame.Jaraxxus_spark
			if not spark then
				spark = PitBull4.Controls.MakeFrame(frame.overlay)
				frame.Jaraxxus_spark = spark

				local texture = PitBull4.Controls.MakeTexture(spark, "OVERLAY")
				spark.texture = texture
				texture:SetTexture([[Interface\CastingBar\UI-CastingBar-Spark]])
				texture:SetVertexColor(1, 1, 1, 0.6)
				texture:SetBlendMode('ADD')
				texture:SetAllPoints(spark)
			end

			spark:ClearAllPoints()
			local reverse = bar:GetReverse() ~= bar:GetDeficit()
			if bar:GetOrientation() == "VERTICAL" then
				spark:SetHeight(20)
				spark:SetWidth(bar:GetWidth() * 2)
				spark.texture:SetTexCoord(1, 0, 0, 0, 1, 1, 0, 1)

				spark:SetPoint("CENTER", bar, reverse and "BOTTOM" or "TOP", 0,
				  ((bar:GetHeight() - 1) / if_duration) * time_left * (reverse and 1 or -1) 
				)
			else
				spark:SetWidth(20)
				spark:SetHeight(bar:GetHeight() * 2)
				spark.texture:SetTexCoord(0, 0, 0, 1, 1, 0, 1, 1)

				spark:SetPoint("CENTER", bar, reverse and "LEFT" or "RIGHT",
				  ((bar:GetWidth() - 1) / if_duration) * time_left * (reverse and 1 or -1),
					0)
			end
		end
	end
end)

local function remove_sparks()
	for frame in PitBull4:IterateFramesForGUID(if_target) do
		if frame.Jaraxxus_spark then
			frame.Jaraxxus_spark.texture = frame.Jaraxxus_spark.texture:Delete()
			frame.Jaraxxus_spark = frame.Jaraxxus_spark:Delete()
		end
	end
end

function PitBull4_Jaraxxus:COMBAT_LOG_EVENT_UNFILTERED(event, timestamp, log_event, src_guid, src_name, src_flags, dst_guid, dst_name, dst_flags, spell_id, spell_name, spell_school, ...)
  if log_event == "SPELL_AURA_APPLIED" and incinerate_fleshes[spell_id] then
		if_target = dst_guid
		if_spell_id = spell_id
		if_spell_name = spell_name
		if_end_time = nil -- don't know when it ends yet
		if_duration = nil -- or how long it lasts
		if_absorbed = 0
		self:UpdateForGUID(dst_guid)
		timer_frame:Show()
	elseif log_event == "SPELL_AURA_REMOVED" and incinerate_fleshes[spell_id] then
		timer_frame:Hide()
		remove_sparks()
		if_target = nil
		self:UpdateForGUID(dst_guid)
	elseif (log_event == "SPELL_HEAL" or log_event == "SPELL_PERIODIC_HEAL") and if_target and dst_guid == if_target then
		local amount, overheal, absorbed, crit = select(1, ...)
		if if_spell_id ~= test_spell_id then
			if_absorbed = if_absorbed + absorbed	
		else
			if_absorbed = if_absorbed + amount
		end
		self:UpdateForGUID(dst_guid)
	end
end

function PitBull4_Jaraxxus:HealComm_HealEvent(event, caster_guid, spell_id, heal_type, end_time, ...)
	if not if_target then return end

	for i = 1, select('#',...) do
		if select(i,...) == if_target then
			self:UpdateForGUID(if_target)
		end
	end
end

function PitBull4_Jaraxxus:HealComm_ModifierChanged(event, guid)
	if not if_target then return end
	if if_target == guid then
		self:UupdateForGUID(if_target)
	end
end
PitBull4_Jaraxxus.HealComm_GUIDDisappeared = PitBull4_Jaraxxus.HealComm_ModifierChanged

function PitBull4_Jaraxxus:GetValue(frame)
	local guid = frame.guid
	if not if_target or not guid or guid ~= if_target then return nil end
	local required_healing = incinerate_fleshes[if_spell_id]

	local extra_value
	if lhc and if_end_time then
		-- Calculate the pending heals if we know when the debuff will end and we
		-- have LibHealComm available.
		local heal_modifier = lhc:GetHealModifier(guid)
		local pending_heals = lhc:GetHealAmount(guid, lhc.ALL_HEALS, if_end_time)
		if pending_heals then
			-- Save the pending heal value for LuaTexts purposes.
			if_target_pending_healing = pending_heals * heal_modifier
			extra_value = if_target_pending_healing / required_healing
		end
	end
	if not extra_value then
		-- No LHC so no known pending heals
		if_target_pending_healing = 0
	end
		
	return if_absorbed / required_healing, extra_value
end

function PitBull4_Jaraxxus:GetExampleValue(frame)
	return nil 
end

function PitBull4_Jaraxxus:GetColor(frame, value)
	return unpack(self.db.profile.global.colors.absorbed)
end

function PitBull4_Jaraxxus:GetExtraColor(frame, value)
	return unpack(self.db.profile.global.colors.pending)
end

-- Support functions to allow LuaTexts to get the data we have and
-- display it as text.
function PitBull4_Jaraxxus:GetRequiredHealing(unit)
	if unit and if_target and UnitGUID(unit) == if_target then
		return incinerate_fleshes[if_spell_id]
	end
end

function PitBull4_Jaraxxus:GetAbsorbed(unit)
	if unit and if_target and UnitGUID(unit) == if_target then
		return if_absorbed
	end
end

function PitBull4_Jaraxxus:GetPending(unit)
	if unit and if_target and UnitGUID(unit) == if_target then
		return if_target_pending_healing
	end
end

PitBull4_Jaraxxus:SetColorOptionsFunction(function(self)
	local function get(info)
		return unpack(self.db.profile.global.colors[info[#info]])
	end
	local function set(info, r, g, b)
		local color = self.db.profile.global.colors[info[#info]]
		color[1], color[2], color[3] = r, g, b
		self:UpdateAll()
	end
	return 'absorbed', {
		type = 'color',
		name = L["Absorbed"],
		desc = L["Color to use for healing already absorbed by Incinerate Flesh."],
		get = get,
		set = set,
	},
	'pending', {
		type = 'color',
		name = L["Pending"],
		desc = L["Color to use for healing that will be abosrbed before Incinerate Flesh fades."],
		get = get,
		set = set,
		hidden = function(info)
			return not lhc
		end,
	},
	function(info)
		local color = self.db.profile.global.colors.absorbed
		color[1], color[2], color[3] = 0, 1, 0
		
		local color = self.db.profile.global.colors.pending
		color[1], color[2], color[3] = 1, 1, 0
		
	end
end)

PitBull4_Jaraxxus:SetLayoutOptionsFunction(function(self)
	return 'toggle_custom_extra', {
		type = 'toggle',
		name = L["Custom pending"],
		desc = L["Whether to override the pending color and use a custom one."],
		order = -30,
		get = function(info)
			local db = PitBull4.Options.GetLayoutDB(self) 
			return db and not not db.custom_extra
		end,
		set = function(info, value)
			if value then
				PitBull4.Options.GetLayoutDB(self).custom_extra = { 0.31, 0.31, 0.31, 1 }
			else
				PitBull4.Options.GetLayoutDB(self).custom_extra = nil
			end
			
			PitBull4.Options.UpdateFrames()
		end,
		hidden = function(info)
			return not lhc
		end,
	}, 'custom_extra', {
		type = 'color',
		name = L["Custom pending"],
		desc = L["What pending color to override the bar with."],
		order = -29,
		get = function(info)
			return unpack(PitBull4.Options.GetLayoutDB(self).custom_extra)
		end,
		set = function(info, r, g, b, a)
			local color = PitBull4.Options.GetLayoutDB(self).custom_extra
			color[1], color[2], color[3], color[4] = r, g, b, a
			
			PitBull4.Options.UpdateFrames()
		end,
		hidden = function(info)
			local db = PitBull4.Options.GetLayoutDB(self)
			return not db or not db.custom_extra or not lhc
		end,
	}
end)
